"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = exports.configureWithClientMainQuery = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectSpread"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _reactRedux = require("react-redux");

var _lifecycle = _interopRequireDefault(require("recompose/lifecycle"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _mapProps = _interopRequireDefault(require("recompose/mapProps"));

var _withProps = _interopRequireDefault(require("recompose/withProps"));

/* eslint-disable import/no-extraneous-dependencies */
// flow-disable-next-line
var configuredFetchPageThunk;

var configureWithClientMainQuery = function configureWithClientMainQuery(fetchPageThunk) {
  configuredFetchPageThunk = fetchPageThunk;
};

exports.configureWithClientMainQuery = configureWithClientMainQuery;
var lifecycle = {
  componentDidMount: function () {
    var _componentDidMount = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee() {
      var _this$props$fetchPage;

      var _this$props, dispatch, route, fetchPageOptions, _route$mainQuery, query, variables, mapRespData, result;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (this.props.isServerRender) {
                _context.next = 12;
                break;
              }

              if (configuredFetchPageThunk) {
                _context.next = 3;
                break;
              }

              throw Error('You must configure a fetchPageThunk with configureWithClientMainQuery');

            case 3:
              _this$props = this.props, dispatch = _this$props.dispatch, route = _this$props.route, fetchPageOptions = _this$props.fetchPageOptions;

              if (!route.mainQuery) {
                _context.next = 10;
                break;
              }

              _route$mainQuery = route.mainQuery, query = _route$mainQuery.query, variables = _route$mainQuery.variables, mapRespData = _route$mainQuery.mapRespData;
              _context.next = 8;
              return dispatch(configuredFetchPageThunk((0, _objectSpread2["default"])({
                query: query,
                variables: variables instanceof Function ? variables(this.props.match.params) : variables,
                mapRespData: mapRespData
              }, fetchPageOptions)));

            case 8:
              result = _context.sent;

              if (fetchPageOptions === null || fetchPageOptions === void 0 ? void 0 : fetchPageOptions.onFinished) {
                fetchPageOptions.onFinished((0, _objectSpread2["default"])({}, this.props, {
                  result: result
                }));
              }

            case 10:
              _context.next = 13;
              break;

            case 12:
              if ((_this$props$fetchPage = this.props.fetchPageOptions) === null || _this$props$fetchPage === void 0 ? void 0 : _this$props$fetchPage.onFinished) {
                this.props.fetchPageOptions.onFinished(this.props);
              }

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function componentDidMount() {
      return _componentDidMount.apply(this, arguments);
    }

    return componentDidMount;
  }()
};

var withClientMainQuery = function withClientMainQuery(fetchPageOptions) {
  return (0, _compose["default"])((0, _withProps["default"])(function (props) {
    return {
      fetchPageOptions: fetchPageOptions instanceof Function ? fetchPageOptions(props) : fetchPageOptions
    };
  }), (0, _reactRedux.connect)(function (_ref) {
    var env = _ref.env;
    return {
      isServerRender: env.isServerRender
    };
  }), (0, _lifecycle["default"])(lifecycle), (0, _mapProps["default"])(function (props) {
    var newProps = (0, _objectSpread2["default"])({}, props);
    delete newProps.fetchPageOptions;
    return newProps;
  }));
};

var _default = withClientMainQuery;
exports["default"] = _default;