"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _compose = _interopRequireDefault(require("recompose/compose"));

var _dynamicDataReductions = require("./dynamic-data-reductions");

test('dynamicDataSetReduction', function () {
  var s = {
    foo: 'foo'
  };
  expect((0, _dynamicDataReductions.dynamicDataSetReduction)({
    bar: 'bar'
  })(s)).toEqual({
    foo: 'foo',
    bar: 'bar'
  });
  expect((0, _compose["default"])((0, _dynamicDataReductions.dynamicDataSetReduction)({
    bar: 'bar'
  }))(s)).toEqual({
    foo: 'foo',
    bar: 'bar'
  });
});
test('dynamicDataDeleteReduction', function () {
  var s = {
    foo: 'foo',
    bar: 'bar'
  };
  expect((0, _dynamicDataReductions.dynamicDataDeleteReduction)('bar')(s)).toEqual({
    foo: 'foo'
  });
  expect((0, _compose["default"])((0, _dynamicDataReductions.dynamicDataDeleteReduction)('bar'))(s)).toEqual({
    foo: 'foo'
  });
});
test('dynamicDataClearReduction', function () {
  var s = {
    foo: 'foo',
    bar: 'bar'
  };
  expect((0, _dynamicDataReductions.dynamicDataClearReduction)()(s)).toEqual({});
  expect((0, _compose["default"])((0, _dynamicDataReductions.dynamicDataClearReduction)())(s)).toEqual({});
});