"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _actions = require("./actions");

var _routerReducer = _interopRequireDefault(require("./router-reducer"));

test('routerReducer', function () {
  var state;
  expect((0, _routerReducer["default"])(state)).toEqual({
    location: {},
    match: {},
    lastAction: null
  });
  state = (0, _routerReducer["default"])(state, (0, _actions.initialNavigation)({
    location: {
      a: 1
    },
    match: {
      b: 2
    }
  }));
  expect(state).toEqual({
    location: {
      a: 1
    },
    match: {
      b: 2
    },
    lastAction: null
  });
  state = (0, _routerReducer["default"])(state, (0, _actions.navigation)({
    location: {
      c: 3
    },
    match: {
      d: 4
    },
    action: 'PLOP'
  }));
  expect(state).toEqual({
    location: {
      c: 3
    },
    match: {
      d: 4
    },
    lastAction: 'PLOP'
  });
});