"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectSpread"));

var _redux = require("redux");

var _reduxThunk = _interopRequireDefault(require("redux-thunk"));

var _reduxLocalstorage = _interopRequireDefault(require("redux-localstorage"));

var _asyncMapReducer = _interopRequireDefault(require("./async-map-reducer"));

var _dynamicDataReducer = _interopRequireDefault(require("./dynamic-data-reducer"));

var _globalDataReducer = _interopRequireDefault(require("./global-data-reducer"));

var _pageDataReducer = _interopRequireDefault(require("./page-data-reducer"));

var _envReducer = _interopRequireDefault(require("./env-reducer"));

var _localReducer = _interopRequireDefault(require("./local-reducer"));

var _routerReducer = _interopRequireDefault(require("./router-reducer"));

var _uiReducer = _interopRequireDefault(require("./ui-reducer"));

var _userReducer = _interopRequireDefault(require("./user-reducer"));

// flow-disable-next-line
// flow-disable-next-line
// flow-disable-next-line
var createSharynStore = function createSharynStore() {
  var _window, _preloadedState;

  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      preloadedState = _ref.preloadedState,
      isDevEnv = _ref.isDevEnv,
      persistLocal = _ref.persistLocal,
      persistUser = _ref.persistUser,
      _ref$asyncMapReducer = _ref.asyncMapReducer,
      asyncMapReducer = _ref$asyncMapReducer === void 0 ? _asyncMapReducer["default"] : _ref$asyncMapReducer,
      _ref$globalDataReduce = _ref.globalDataReducer,
      globalDataReducer = _ref$globalDataReduce === void 0 ? _globalDataReducer["default"] : _ref$globalDataReduce,
      _ref$dynamicDataReduc = _ref.dynamicDataReducer,
      dynamicDataReducer = _ref$dynamicDataReduc === void 0 ? _dynamicDataReducer["default"] : _ref$dynamicDataReduc,
      _ref$pageDataReducer = _ref.pageDataReducer,
      pageDataReducer = _ref$pageDataReducer === void 0 ? _pageDataReducer["default"] : _ref$pageDataReducer,
      _ref$envReducer = _ref.envReducer,
      envReducer = _ref$envReducer === void 0 ? _envReducer["default"] : _ref$envReducer,
      _ref$localReducer = _ref.localReducer,
      localReducer = _ref$localReducer === void 0 ? _localReducer["default"] : _ref$localReducer,
      _ref$routerReducer = _ref.routerReducer,
      routerReducer = _ref$routerReducer === void 0 ? _routerReducer["default"] : _ref$routerReducer,
      _ref$uiReducer = _ref.uiReducer,
      uiReducer = _ref$uiReducer === void 0 ? _uiReducer["default"] : _ref$uiReducer,
      _ref$userReducer = _ref.userReducer,
      userReducer = _ref$userReducer === void 0 ? _userReducer["default"] : _ref$userReducer,
      _ref$extraReducers = _ref.extraReducers,
      extraReducers = _ref$extraReducers === void 0 ? {} : _ref$extraReducers;

  var reducerKeysToPersist = [];
  persistLocal && reducerKeysToPersist.push('local');
  persistUser && reducerKeysToPersist.push('user');
  var composeEnhancers = isDevEnv && ((_window = window) === null || _window === void 0 ? void 0 : _window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__) || _redux.compose;
  var composedEnhancers = composeEnhancers((0, _redux.applyMiddleware)(_reduxThunk["default"]), reducerKeysToPersist.length ? (0, _reduxLocalstorage["default"])(reducerKeysToPersist) : function (x) {
    return x;
  });
  return (0, _redux.createStore)((0, _redux.combineReducers)((0, _objectSpread2["default"])({
    asyncMap: asyncMapReducer,
    dynamicData: dynamicDataReducer,
    globalData: globalDataReducer,
    pageData: pageDataReducer,
    env: envReducer
  }, persistLocal ? {
    local: localReducer
  } : {}, {
    ui: uiReducer,
    user: userReducer,
    router: routerReducer
  }, extraReducers)), (_preloadedState = preloadedState) !== null && _preloadedState !== void 0 ? _preloadedState : composedEnhancers, preloadedState ? composedEnhancers : undefined);
};

var _default = createSharynStore;
exports["default"] = _default;