"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectSpread"));

var _serializeJavascript = _interopRequireDefault(require("serialize-javascript"));

var _checkSetup = require("@sharyn/check-setup");

var _env = require("@sharyn/env");

// flow-disable-next-line
var preloadedState = function preloadedState() {
  var customEnv = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return (0, _serializeJavascript["default"])({
    env: (0, _objectSpread2["default"])({
      API_URL: _env.API_URL,
      SSE_URL: _env.SSE_URL,
      IS_DEV_ENV: _env.IS_DEV_ENV,
      SERVER_VERSION: _env.NO_VERSION_VALIDATION ? null : (0, _checkSetup.dirChecksum)('src', ['package.json', 'yarn.lock']),
      isOnline: true,
      isServerRender: true
    }, customEnv)
  });
};

var getInjections = function getInjections(customEnv) {
  return [['"%%PRELOADED_STATE%%"', preloadedState(customEnv)], ['%%BUNDLE_URL%%', _env.NODE_ENV === 'production' ? '/static/js/bundle.js' : "http://localhost:".concat(_env.WDS_PORT || 8072, "/static/js/bundle.js")], ['<!-- %%SERVICE_WORKER%% -->', _env.TURN_OFF_SW ? '' : "<script>navigator.serviceWorker && window.addEventListener('load', () => navigator.serviceWorker.register('/sw.js'))</script>"]];
};

var createHtml = function createHtml(rawIndexHtml) {
  var customEnv = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return getInjections(customEnv).reduce(function (currentHtml, injection) {
    return currentHtml.replace(injection[0], injection[1]);
  }, rawIndexHtml);
};

var _default = createHtml;
exports["default"] = _default;